using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using UnityEngine.Events;
using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;
using AssetBundles;

namespace Unique
{
    public class ObliterateCUACameras : MVRScript
    {
        public string pluginAuthor = "unique";
        public string pluginName = "ObliterateCUACameras";
        public string pluginVersion = "1.0";
        public string pluginDate = "2022-01-30";
        public string pluginDescription =
 @"
 Searches for and obliterates all custom unity asset cameras to fix VR.
 ";
   
        private float myClock = -1.0f;
        
        // Use this for initialization
        public override void Init()
        {
            // Usage text...
            JSONStorableString usageInfoTextJSON = new JSONStorableString("", "\nSearches for and obliterates all custom unity asset cameras to fix VR.\n\nShould be added as a Scene or Session plugin.\n\nNothing to configure here.");
            UIDynamicTextField usageInfoText = CreateTextField(usageInfoTextJSON);
            usageInfoText.backgroundColor = new Color32(60, 58, 210, 255);
            usageInfoText.height = 280f;
            usageInfoText.textColor = Color.white;

            Update();
        }
        
        void Update()
        {
            myClock -= Time.deltaTime;
            
            if (myClock > 0.0f)
            {// wait
                return;
            }
            
            myClock += 10.0f;
            myClock = Mathf.Max(myClock, 0.0f);
            
            try
            {
                foreach (Atom atom in FindObjectsOfType(typeof(Atom)))
                {
                    //SuperController.LogMessage("atom = " + atom.name + " atomtype = " + atom.type);
                  
                    if (atom.type == "CustomUnityAsset")
                    {
                        foreach (Camera camera in atom.GetComponentsInChildren<Camera>())
                        {
                            Destroy(camera);
                        }
                    }
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
    }
}
